/*	$Id: symbol.h,v 1.1.1.1 1999/10/05 23:58:37 leonard Exp $	*/
/* Copyright 1999, David Leonard. The University of Queensland, Australia. */

typedef int symbol_t;

#define MAXSYMS 	256
#define MAXRHS 		128
#define NO_SYMBOL 	((symbol_t) -1)		/* no symbol */
#define EPSILON		((symbol_t) 0)		/* special symbol */

/* Bit vector of symbols */
#define _BITTYPE	unsigned char
#define NBITS		(8 * sizeof (_BITTYPE))
typedef struct symset {
	_BITTYPE	bits[MAXSYMS/NBITS];
} symset_t;

void	symsetempty(symset_t *);
int	symsetcmp(const symset_t *, const symset_t *);
int	symsetisempty(const symset_t *);
void	symsetadd(symset_t *, const symbol_t);
void	symsetdel(symset_t *, const symbol_t);
int	symsetin(const symset_t *, const symbol_t);
void	symsetunion(symset_t *, const symset_t *);
symbol_t symsetnext(const symset_t *, symbol_t);
int	symsetisect(const symset_t *, const symset_t *, symset_t *);

#define SYMSET_FOREACH(sym, set) \
	for (sym = symsetnext(set, NO_SYMBOL); \
	     sym != NO_SYMBOL; \
	     sym = symsetnext(set, sym))

